#!/usr/local/bin/perl
# bunki.cgi of 3dai relayed novel version 2.11.
# Copyright (C) 2000-2002 Izui Masakazu & Ito Akihiro.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
# 2001/7/1
use strict;
require 'sub.pl';
require 'bunkiinfo2.pl';
main();
exit;

sub main(){
	local $main::pass, @main::pass;
	pre();
	local $main::sign = sign();
	local $main::tag = make_tag($main::sign);
	html::http_head(0);
	html::html_head($main::tag);
	disp_hash($main::tag, make_hash("./$main::data_dir/bnk$main::pass\.txt"), [prev_link(), '߂']);
	print "<HR>\n";	
	info::bunkiinfo2($main::pass, $main::sign);
}

sub pre(){
	die 'QƏ񂪕sł' unless (-e qq|$main::data_dir/bnk$main::FORM{'bunki'}.txt|);
	@main::pass = (substr($main::FORM{'bunki'}, 0, 2), split //, substr($main::FORM{'bunki'}, 2));
	$main::pass = join '', @main::pass;
}

sub sign(){
	$main::pass[0] + scalar @main::pass -1<=> $main::ksn_max;
}

sub make_tag($){
	if ($_[0] < 0) {
		' ' . join('/', @main::pass);
	} elsif ($_[0] == 0) {
		' ' . join('/', @main::pass) . '(ŏI)';
	} else {
		'z ' . join('/', @main::pass);
	}
}

sub prev_link(){
	(scalar @main::pass == 2) ?
	"./kansen.cgi?top=$main::pass[0]" :
	'./bunki.cgi?bunki=' . join('', @main::pass[0..$#main::pass - 1]);
}

