# bunkiinfo.pl of 3dai relayed novel version 2.11.
# Copyright (C) 2000-2002 Izui Masakazu & Ito Akihiro.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
package info;
use strict;

sub BEGIN() {
	@info::info;
	opendir DIR, $main::data_dir or warn q|Can't open data_dir.|;
	grep {
		if ($_ =~ /^bnk(\d{2})([1-5]{1,3})\.txt$/) {
			$info::info[$1] .= "$2\t";
		} else { 0; }
	} readdir DIR;
	closedir DIR;
	@info::info = map { [split /\t/] } @info::info[0..$main::ksn_len];
}

#̕\
sub bunkiinfo($){
	my $i = sprintf ("%02d", $_[0]);
	my ($label_a, $label_b);
	if ($i == 0) {
		($label_a, $label_b) = ('Pb ', 'Pbڂ𓊍e');
	} elsif ($i == $main::ksn_max) {
		($label_a, $label_b) = ('z', 'z');
	} elsif ($i == $main::ksn_max - 1) {
		($label_a, $label_b) = ('ŏI', 'ŏI');
	} else {
		($label_a, $label_b) = ('', '');
	}

	my @message = map { qq|<A HREF="./bunki.cgi?bunki=$i$_">$label_a $_</A>| } bunkiarray($i);
	if ($i == $main::ksn_len and $i < $main::ksn_max) {
		$message[scalar @message]
			= (count_bunki($i) < 5) ?
			qq|<A HREF="./form.cgi?bunki=$i">$label_b</A>| :
			qq|<FONT COLOR="#aaaaaa">($label_b)</FONT>|;
	}
	if (@message) {
		print "<UL>\n";
		grep { print qq|<LI>$_\n| } @message;
		print "</UL>\n";
	}
}

sub sentaninfo(){
	my @message = map {
		qq|<A HREF="bunki.cgi?bunki=$main::ksn_len$_">$main::ksn_len/|
		. join ('/', split (//, $_)) . qq|</A>|;
	} sort @{$info::info[$main::ksn_len]};
	if ($main::ksn_len != 0) {
		unshift(@message,  qq|<A HREF="kansen.cgi?top=$main::ksn_len">$main::ksn_len</A>|);
	} else {
		$message[scalar @message] = qq|<A HREF="form.cgi?bunki=00">1bڂ𓊍e</A>|;
	}
	unless (@message) {
		$message[0] = '݁Ae͂܂B';
	}
	print "<UL>\n";
		grep { print qq|<LI>$_\n|; } @message;
	print "</UL>\n";
}

sub bunkiarray($){
	map { substr($_, -1, 1) } grep {  2 + length($_) == length($_[0]) + 1} sort @{$info::info[substr($_[0], 0, 2)]};
}

sub count_bunki($){
	 scalar bunkiarray($_[0]);
}

1;
