#!/usr/local/bin/perl
# kansen.cgi of 3dai relayed novel version 2.11.
# Copyright (C) 2000-2002 Izui Masakazu & Ito Akihiro.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
# 2001/7/1
use strict;
require 'sub.pl';
require 'bunkiinfo.pl';

main();
exit;

sub main(){
	html::http_head(0);
	html::html_head('');
	print "<H1 ALIGN=center>\\</H1>\n";
	my ($top, $bottom, $len) = def_range();
	info($top, $bottom, $len);
	print_link($top - 5, 'O֖߂') if $top > 1;
	disp_article($top, $bottom);
	print_link($bottom + 1, 'ǂ') if $bottom != $main::ksn_len;
}

sub print_link($$){
	print qq|<DIV ALIGN=center>y<A HREF="kansen.cgi?top=$_[0]">$_[1]</A>z</DIV>\n|;
}

sub info($$$){
	if ($main::ksn_len == $main::ksn_max) {
		print qq|<P>łɂ̏͊܂B</P>\n|;
		return 0;
	}
	my ($top, $bottom, $len, $ksn_len) = (@_[0..2], $main::ksn_len + 0);
	print "<P>݂̍Ő[̏</P>\n";
	info::sentaninfo($main::ksn_len);
	my $nokori = $main::ksn_max - $main::ksn_len;
	print "<P>܂ł $nokori b!!</P>\n";

	print qq"<P>$top񂩂$bottom";
	print "(Ő[)" if $bottom == $main::ksn_len;
	print "܂ł̊(v$len)\\܂B</P>\n";
	print "<P>Ő[̑$ksn_len񂨂сA̕ɑēe邱Ƃł܂B<BR>
Ał5̕򂪂łĂꏊ͓eł܂B</P>\n";
}

#\͈
sub def_range(){
	my($top, $bottom, $len)  = ($main::FORM{'top'}, $main::FORM{'bottom'}, $main::FORM{'len'});
	$top= 1 if  $top < 1;	# top
	if ($top <= $bottom) {	#$bottomɗLȒlƂ
		if ($bottom > $main::ksn_len) {
			$bottom = $main::ksn_len;
		}
		$len = $bottom - $top + 1;
	} elsif ($len != 0 && $top + $len - 1 <= $main::ksn_len) {	#$lenɗLȒlƂ͋~
		$bottom = $top + $len - 1;
	} else {	#Ƃ͖ⓚp
		$bottom = $main::ksn_len;
		$len = $bottom - $top +1;
	}
	(int $top, int $bottom, int $len);
}

#L̕\
sub disp_article($$) {
	grep {
		my $i = $_;
		print qq"<HR>\n";
		disp_hash(sprintf(" %d ", $i), make_hash(sprintf("$main::data_dir/ksn%02d.txt", $i )));
		info::bunkiinfo($i);
	} ($_[0]..$_[1]);
}

