#!/usr/local/bin/perl
# form.cgi of 3dai relayed novel version 2.11.
# Copyright (C) 2000-2002 Izui Masakazu & Ito Akihiro.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
# 2001/9/11
use strict;
require 'sub.pl';
require 'bunkiinfo2.pl';

main();
exit;

sub main(){
	local $main::pass, @main::pass;
	local %main::value; #fobOp
	pre();
	local $main::tag = make_tag(sign());
	html::http_head(0);
	html::html_head('e');
	print_pre();
	print "<HR>\n";
	print_form();
}

sub pre(){
	if ($main::ksn_len >= $main::ksn_max) {
		die qq|̊͂łɏI܂B<BR>\n炭̂ڂ肪Ƃ܂B|;
	}
	@main::pass = (substr($main::FORM{'bunki'}, 0, 2), split //, substr($main::FORM{'bunki'}, 2));
	$main::pass = join '', @main::pass;
	if ($main::pass[0] != $main::ksn_len){
		die qq|Vт܂B<BR>
x<A HREF="./kansen.cgi?top=$main::ksn_len"></A>炽ǂĂB|;
	}
	if (scalar info::bunkiarray($main::pass) >= 5) {
		die '̏ꏊ͂ȏ㕪ł܂B';
	}
}

sub sign(){
	$main::ksn_len + scalar @main::pass <=> $main::ksn_max;
}

sub make_tag($){
	if ($_[0] < 0) {
		 join('/', @main::pass) . '̕';
	} elsif ($_[0] == 0) {
		join('/', @main::pass) . '̕(ŏI)';
	} else {
		"$main::titleǂ񂾊z";
	}
}

sub prev_link(){
	(scalar @main::pass == 2) ?
	"./kansen.cgi?top=$main::pass[0]" :
	'./bunki.cgi?bunki=' . substr($main::pass, 0, length $main::pass - 1);
}

sub print_pre(){
	if ($main::ksn_len + scalar @main::pass  == 1) {
		print "<P> 1 ̂͂܂B</P>\n";
		return 0;
	}
	my $hash = (scalar @main::pass  == 1) ?
		make_hash("$main::data_dir/ksn$main::pass.txt") :
		make_hash("$main::data_dir/bnk$main::pass.txt");
	disp_hash("Ob", $hash, [prev_link(), '߂']);
}

sub prev_link(){
	(scalar @main::pass == 1) ?
	"./kansen.cgi?top=$main::pass[0]" :
	'./bunki.cgi?bunki=' . join('', @main::pass);
}

sub print_form(){
	print qq|<H2>etH[($main::tag)</H2>
<FORM ACTION="./kakunin.cgi" METHOD="post">
<INPUT TYPE="hidden" NAME="bunki" VALUE="$main::FORM{'bunki'}">
<P>{F<BR>
<TEXTAREA NAME="article" ROWS=30 COLS=40 wrap=virtual VALUE=""></TEXTAREA></P>
<P>RgF<BR>
<TEXTAREA NAME="comment" ROWS=4 COLS=40 wrap=virtual VALUE=""></TEXTAREA></P>
<P>ւ̂F
<INPUT TYPE="text" NAME="odai1" MAXLENGTH=14 SIZE=10 VALUE="$main::value{'odai1'}">
E<INPUT TYPE="text" NAME="odai2" MAXLENGTH=14 SIZE=10 VALUE="$main::value{'odai2'}">
E<INPUT TYPE="text" NAME="odai3" MAXLENGTH=14 SIZE=10 VALUE="$main::value{'odai3'}"><BR>
 l̂߂ɁAgp₷o悤ɂ܂傤B</P>
<P><A HREF="$main::doc_url/guide.html#kensyutu">oIvV</A>F
<INPUT TYPE="text" NAME="option" MAXLENGTH=20 SIZE=10 VALUE=""></P>
<P>yl[F<INPUT TYPE="text" NAME="myname" MAXLENGTH=15 SIZE=10 VALUE="$html::Cookies{'myname'}"><BR>
[AhXF<INPUT TYPE="text" NAME="mail" SIZE=20 VALUE="$html::Cookies{'mail'}"></P>
<P><INPUT TYPE="submit" VALUE="==== \\mF ===="><BR>
<SMALL><INPUT TYPE="reset" VALUE=Reset></SMALL></P>
</FORM>|;
}

