# sub.pl of 3dai relayed novel version 2.11.
# Copyright (C) 2000-2002 Izui Masakazu & Ito Akihiro.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
push @INC, './libs/';
use strict;

require 'pref.pl';
require 'html.pl';
%main::FORM = map { (split /\=/)[0,1] } split /\&/, $ENV{'QUERY_STRING'};

# ̃t@C擾
sub get_ksn_len(){
	my $length;
	my @kansen;
	opendir DIR, "$main::data_dir" or die q|Can't open data_dir.|;
	@kansen = sort grep /^ksn(\d{2})\.txt$/, readdir DIR;
	closedir DIR;
	scalar @kansen - 1;
}
$main::ksn_len = sprintf("%02d", get_ksn_len());

# lmF
sub check_perf(){
	no strict "refs";
	grep {
		warn("Undefined \$$_.") unless ${$_};
	} ('main::ksn_len', 'main::data_dir', 'main::ksn_max', 'main::odai_color', 'main::odai2_color');
}
check_perf();

# ^ꂽꏊ̕򂪂݂邩ԂB
#̏ 01/1/1 ̌`
sub bunki_cnt($){
	my $pass = join '', split /\//, $_[0];
	opendir DIR, $main::data_dir or warn q|Can't open data_dir.|;
	my @bunki_files = sort grep {/^bnk$pass([1-5])\.txt$/} readdir DIR;
	closedir DIR;
	scalar @bunki_files;
}


# f[^t@CJănbVɂ
sub make_hash($){
	open FILE, $_[0] or die qq|Can't open file "$_[0]".|;
	my $data = { map { chomp; (split /\t/)[0,1]; } <FILE>};
	close FILE;
	$data;
}

##### nbV󂯎ċLƂĐ`Ao
# PFHAB
# QȉFdata nbVւ̃t@X
# ߂郊N
sub disp_hash($$;$){
	my %data = %{$_[1]};
	print qq|<H2 CLASS="article">$_[0]</H2>\n|;
	if ($_[2]) { print qq|<DIV>[<A HREF="$_[2]->[0]">$_[2]->[1]</A>]</DIV>\n|; }
	if ($_[1]->{'pdai1'}.$_[1]->{'pdai2'}.$_[1]->{'pdai3'}) {
		print qq|<DIV>F
<FONT COLOR="$main::odai_color">$_[1]->{'pdai1'}</FONT>^
<FONT COLOR="$main::odai_color">$_[1]->{'pdai2'}</FONT>^
<FONT COLOR="$main::odai_color">$_[1]->{'pdai3'}</FONT></DIV>
<BR CLASS="article">
|;
	}
#	$_[1]->{'article'} =~ s|<P>|<P CLASS="article">|g;
#	$_[1]->{'article'} =~ s|<DIV>|<DIV CLASS="article">|g;
#	$_[1]->{'article'} =~ s|<BLOCKQUOTE>|<BLOCKQUOTE CLASS="article">\n|g;
#	$_[1]->{'article'} =~ s|<BR>|<BR CLASS="article">\n|g;
	$_[1]->{'article'} =~ s|<ODAI>|<FONT COLOR="$main::odai2_color">|g;
	$_[1]->{'article'} =~ s|</ODAI>|</FONT>|g;
	$_[1]->{'article'} =~ s|</P>|</P>\n|g;
	$_[1]->{'article'} =~ s|</DIV>|</DIV>\n|g;
	$_[1]->{'article'} =~ s|</BLOCKQUOTE>|</BLOCKQUOTE>\n|g;

	print qq|<BLOCKQUOTE>$_[1]->{'article'}</BLOCKQUOTE>\n<HR>\n|;
	if ($_[1]->{'comment'}) {
		print qq|<BLOCKQUOTE>\n<P>$_[1]->{'comment'}</P>\n</BLOCKQUOTE>\n|;
	}
	if ($_[1]->{'mail'}) {
		print qq|<P><A HREF="mailto:$_[1]->{'mail'}">$_[1]->{'myname'}</a>\n|;
	} else {
		print qq|<P>$_[1]->{'myname'}\n|;
	}
	print make_date(hex $_[1]->{'date'});
	print qq|<BR>
ւ̂F
<FONT COLOR="$main::odai_color">$_[1]->{'odai1'}</FONT>^
<FONT COLOR="$main::odai_color">$_[1]->{'odai2'}</FONT>^
<FONT COLOR="$main::odai_color">$_[1]->{'odai3'}</FONT></P>
|;
}

sub make_date($){
	my($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime($_[0]);
	sprintf("%04d/%02d/%02d", $year + 1900, $mon + 1, $mday);
}

sub check_expire(){
	my @made = (00, 00, 00, 31, 01, 02); # ver.2.06
	my @now  = localtime(time);
	if (date_cmp([@made[3,4], $made[5] + 102], [$now[3], $now[4] + 1, $now[5]]) < 0) {
		warn '҂F̃XNvg͎xłBŐVłpB';
	}
}
#check_expire();

sub date_cmp($$){
	my ($a, $b) = @_;
	$a->[2] <=> $b->[2] || $a->[1] <=> $b->[1] || $a->[0] <=> $b->[0];
}


1;
